# combo - content management system
# Copyright (C) 2015  Entr'ouvert
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import json

from django.http import HttpResponse
from haystack.query import SearchQuerySet

from .models import SearchCell


def search(request, pk):
    cell = SearchCell.objects.get(id=pk)
    # TODO: check the cell page is accessible to user, alter search parameters,
    # etc.
    query = request.GET.get('q')
    searchqueryset = SearchQuerySet()
    sqs = searchqueryset.auto_query(query).highlight()
    sqs.load_all()

    result = []
    for item in sqs:
        result.append({'title': item.title, 'url': item.url,
            'highlighted': item.highlighted['text'][0]})

    response = HttpResponse(content_type='application/json')
    json.dump({'data': result}, response, indent=2)
    return response
